###*
# Contains all timers.
# @type {{}}
###

timers = {}

###*
# Timers factory object.
# @param name
# @returns {*}
###

timer = (name) ->
  if typeof timers[name] == 'undefined'
    timers[name] =
      ticks: []
      median: ->
        @ticks.sort (a, b) ->
          a.getDiff() - b.getDiff()
        half = Math.floor(@ticks.length / 2)
        if @ticks.length % 2
          @ticks[half].getDiff()
        else
          @ticks[half - 1].getDiff() + @ticks[half].getDiff() / 2
      mean: ->
        @duration() / @ticks.length
      duration: ->
        i = 0
        sum = 0
        while i < @ticks.length
          sum += @ticks[i].getDiff()
          i++
        sum
      min: ->
        min = @ticks[0].getDiff()
        @ticks.forEach (tick) ->
          if tick.getDiff() < min
            min = tick.getDiff()
        min
      max: ->
        max = 0
        @ticks.forEach (tick) ->
          if tick.getDiff() > max
            max = tick.getDiff()
        max
      start: ->
        @ticks[0].getStart()
      end: ->
        lastTick = @ticks[@ticks.length - 1]
        lastTick.getStart() + lastTick.getDiff()
      count: ->
        Object.keys(@ticks).length
      parse: (num) ->
        if num < 1e3
          return num + 'ns'
        else if num >= 1e3 and num < 1e6
          return num / 1e3 + 'us'
        else if num >= 1e6 and num < 1e9
          return num / 1e6 + 'ms'
        else if num >= 1e9
          return num / 1e9 + 's'
        return
  timers[name]

###*
# Starts the tick.
###

###*
# Constructor of tick.
# @param name The name of this tick.
# @returns {Tick}
# @constructor
###

Tick = (name) ->
  @name = name
  this

Tick::start = ->
  @hrstart = process.hrtime()

###*
# Ends the tick.
###

Tick::stop = ->
  @hrend = process.hrtime(@hrstart)
  timer(@name).ticks.push this

###*
# Get the start of the tick.
# @returns Long nanoseconds
###

Tick::getStart = ->
  @hrstart[0] * 1e9 + @hrstart[1]

###*
# Get the duration of the tick.
# @returns Long nanoseconds
###

Tick::getDiff = ->
  @hrend[0] * 1e9 + @hrend[1]

module.exports =
  timers: timers
  Tick: Tick

# ---
# generated by js2coffee 2.0.4